// ----------------------------------------------------
// Alchy Cooking Fletching Lockpick Macro XP Loop
// Release 2.2
// Based on the bones of : 	AllInOne.js ACScript macro which
// 	was based on :		Quaestor Buffing Mule Rev 2
//	with XP input from:	Slave Boy's Ultimate Tradesman Macro for ACTool
//					by Leviticus
// 
// by Therkyn of MT
//
// Read the Readme.txt included in the package.
// 
// This is a command driven macro.
// Spouse Abort is set up for those of you sharing a PC with a spouse who isnt an AC fan.
// Based on the time set in your arguments section, the program will end, and log out
// of AC when the hour arrives.  My default is 5 PM.  This ensures the PC will be free
// for my wife when she makes it home.
var SpouseAbort = false;
var SpouseAbortHour = 17;
// Buff Bot handling:  Currently runs every hour.  If the bot's busy, you're out of luck.
// in the future I'll check spell status and request every 5 mins until I've got the spells
// cast on me.
var BuffBotExists = true;
var BuffBotName = "botname"
var BuffBotCommand = "pr trades, pr xp, bow, ua, strength, critter, manar"

// Just in case you want to eliminate a step:
var AlchemyExists = true;
var FletchingExists = true;
var CookingExists = true;
var LockpickExists = true;
var GlyphExists = true;  // Free XP to a weapon skill
var CritterExists = true;  // Added for some extra XP.  Very minimal ATM, could be expanded
			   // but I've not gotten scrolls.  Will skip when Pris Tapers are low.

//  Items that can be customized:
//  Alchemy Items: 
var GemToGrind = "Azurite";
var TonguesOrGuts = "Braided Drudge Ravener Guts"; // "Braided Drudge Ravener Guts" or "Braided Sclavus Tongues"

//  Cooking Items:
var FoodItem = "Pizza";  // "Meat Pie" if making, "Pizza" if Buying @ Cragstone
var Sinew = "Small Lugian Sinew"; // Cook the sinew of your choice...
var DyePot = "Lapyan Dye Pot"; //Color of your choice
var ClothingItem = "Suikan Robe"; //Dye the item of your choice

//  Fletching Items:
var TypeOfUndeadBone = "Dark Revenant Thighbone";  // "Dark Revenant Thighbone" or "Undead Thighbone"

// Files:
// Components Burned Report:
var tfBurnedComps = "C:\\ACF-BurnedComps.txt";
// Completed Items to Restock:
var tfRestockItems = "c:\\ACF-RestockList.txt";
// Commands to Prep with (restock from raw components):
var tfPrepCommands = "c:\\ACF-PrepCommands.txt";
// The list of items you need to purchase to make everything
var tfRawPurchases = "c:\\ACF-RawPurchaseList.txt";
// The Inventory List - Stocking vs actual
var tfInventoryList = "c:\\ACF-InventoryLog.txt";

// Where to buy:
// Hot Peppers... Al-Jalima Spice Merchant 
// Cinnamon... Al-Jalima Spice Merchant 
// Hot Sauce... Baishi Spice Merchant 
// Cinnamon Bark... Baishi Spice Merchant 
// Pizza... Cragstone Bartender (35.7N, 49.2E) 
// Apples, Cheese, Meat... Cragstone Farmer (SW of town on road)
// Water, Flour... Hebian-to Merchant
// Mana Draughts... Any healer's shop or make them yourself 
// Ice Balls... Outside Qalabar -- Jolly Snowman (73.2S 26.8E) 
// Gems... Qalabar Jewelry Shop
// Sausage... McNeil's Freehold 

// Skill steps that earn < 30 xp have been commented out because they will require lengthening
// the overall loop timer to allow them to earn any XP (130 secs min will cause steps earning
// 20 xp to miss most of the time due to the way the XP is pro-rated).  They are included for
// reference only.

// ---------------------------------------------------------------------------------------
// Alchemy - Tradeskill - Must have a full pack, if your pack is not full, it will attempt
// to fill the pack with Bloodseeker infusions.  If you dont have enough quicksilver to
// fill your pack, you will not execute any alchemy steps until the pack is full.
// ---------------------------------------------------------------------------------------
var AlchemySteps = new Array(
new Array("Mortar and Pestle",GemToGrind, 5),					//  40 xp
new Array("Mortar and Pestle","Hot Pepper", 5),   					//  50 xp
new Array("Alembic","Quicksilver", 5),						//  55 xp
new Array("Alembic","Stibnite", 5),						//  70 xp
new Array("Bloodseeker Infusion","Aqua Incanta", 5),				//  75 xp
new Array("Alembic","Quicksilver Pea", 5),						//  85 xp
new Array("Mana Infusion","Aqua Incanta",10),					//  90 xp
new Array("Mortar and Pestle","Cinnamon Bark",10),					// 100 xp
new Array("Concentrated Bloodseeker Infusion","Concentrated Aqua Incanta",15),	// 105 xp
new Array("Concentrated Bloodhunter Infusion","Concentrated Aqua Incanta",15),	// 120 xp
new Array("Victual Infusion","Aqua Incanta",15),					// 135 xp
//new Array("Pyreal Bar","Pyreal Bar"),	// 150 xp -- Historical, new code doesnt handle
new Array("Neutral Balm","Chorizite Oil",15),					// 150 xp
new Array("Victual Infusion","Mana Draught",20),					// 180 xp
new Array("Neutral Balm", "Strong Chorizite Oil",20),				// 200 xp
new Array("Bloodseeker Oil",TonguesOrGuts,1),					// 220 xp
new Array("Neutral Balm","Concentrated Chorizite Oil",40),				// 250 xp
new Array("Neutral Balm","Condensed Chorizite Oil",40),				// 300 xp
new Array("Thin Diamond Oil","Quality Pyreal Ingot",1),				// 350 xp
new Array("Thick Diamond Oil","Quality Pyreal Ingot",1)); 				// 425 xp
//new Array("Decanter of Essence", "Diamond Powder",1));				// 425 xp


// ---------------------------------------------------------------------------------------
// Cooking - Tradeskill - Must have a full pack, if your pack is not full, it will attempt
// to fill the pack with applesauce.  If you dont have enough applesauce to fill the pack
// it will abort the loop.
// ---------------------------------------------------------------------------------------
var CookingSteps = new Array(
//new Array("Flour", "Water"),							//   1 xp
//new Array("Frying Pan","Dough"),						//   5 xp
//new Array("Carving Knife","Cabbage"),						//   7 xp
//new Array("Cooking Pot","Steak"),						//  15 xp
// new Array("Dough","Steak",5),							//  20 xp
new Array("Heavy Grinder","Apple",5),						//  30 xp
new Array("Carving Knife","Brimstone-cap Mushroom",5),				//  40 xp
new Array("Cinnamon", "Apple",5),							//  50 xp
new Array("Heavy Grinder", "Steak",5),						//  60 xp
new Array("Noodle Cutter","Batter",10),						//  80 xp
new Array("Carving Knife", "Jack o' Lantern",1),					//  90 xp
new Array("Mana Oil", FoodItem,15),						// 100 xp
new Array("Baking Pan","Cheese Filled Mushroom",15),				// 120 xp
new Array("Victual Oil", FoodItem,20),						// 150 xp
new Array("Hot Sauce", "Sausage",45),						// 190 xp
new Array("Heavy Grinder", "Magic Iceball",50),					// 200 xp
new Array("Cooking Pot", Sinew,1),						// 220 xp
new Array(DyePot, ClothingItem,1),						// 230 xp
new Array("Raw Egg Noodles","Ground Meat",50));					// 250 xp

// ---------------------------------------------------------------------------------------
// Fletching - Tradeskill - Must have a full pack, if your pack is not full, it will attempt
// to fill the pack with greater arrowheads.  If you cannot do so, it will not execute any
// fletching steps.  Do not worry about commenting out any steps, if you dont have them they
// wont dramatically delay the execution of the loop.  You may comment out the two dupe
// lines if you have both in inventory.
// ---------------------------------------------------------------------------------------
var FletchingSteps = new Array(
//new Array("Bundle of Arrowheads","Bundle of Arrowshafts"),			//   5 xp
//new Array("Bundle of Blunt Arrowheads", "Bundle of Arrowshafts"),		//  10 xp
// new Array("Bundle of Frog Crotch Arrowheads", "Bundle of Arrowshafts",5),		//  20 xp
new Array("Fire Oil","Bundle of Greater Arrowheads",5),				//  30 xp
new Array("Wrapped Bundle of Arrowheads", "Wrapped Bundle of Arrowshafts",5),	//  35 xp
new Array("Wrapped Bundle of Blunt Arrowheads", "Wrapped Bundle of Arrowshafts",5),// 40 xp
new Array("Wrapped Bundle of Frog Crotch Arrowheads","Wrapped Bundle of Arrowshafts",5),// 50 xp
new Array("Bloodseeker Oil","Bundle of Arrowheads",5),				//  60 xp
new Array("Bloodhunter Oil", "Bundle of Greater Arrowheads",5),			//  70 xp
new Array("Whittling Knife","Long Sticks",5),					//  75 xp
new Array("Bloodseeker Oil","Bundle of Frog Crotch Arrowheads",5),		//  80 xp
new Array("Whittling Knife","Jack o' Lantern",1),					//  90 xp
new Array("Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Arrowheads",10),// 110 xp
new Array("Bundle of Greater Arrowheads","Bundle of Arrowshafts",10),		// 120 xp
new Array("Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Blunt Arrowheads",15),// 125 xp
new Array("Bundle of Greater Blunt Arrowheads","Bundle of Arrowshafts",15),	// 140 xp
new Array("Wrapped Bundle of Greater Arrowheads","Wrapped Bundle of Arrowshafts",20),// 150 xp
new Array("Bundle of Greater Frog Crotch Arrowheads","Bundle of Arrowshafts",20),	// 160 xp
new Array("Wrapped Bundle of Greater Blunt Arrowheads","Wrapped Bundle of Arrowshafts",20),// 170 xp
new Array("Bundle of Deadly Frog Crotch Arrowheads","Bundle of Arrowshafts",25),	// 175 xp
new Array("Wrapped Bundle of Deadly Blunt Arrowheads","Wrapped Bundle of Arrowshafts",25),// 180 xp
new Array("Wrapped Bundle of Greater Frog Crotch Arrowheads","Wrapped Bundle of Arrowshafts",40),// 190 xp
new Array("Barbed Fletching Tool", "Bundle of Greater Arrowheads",50),		// 200 xp
//new Array("Bundle of Greater Fire Arrowheads", "Bundle of Arrowshafts"),	// 200 xp - Dupe
new Array("Whittling Knife", TypeOfUndeadBone,1),					// 220 xp
new Array("Bundle of Deadly Fire Arrowheads","Bundle of Arrowshafts",100),		// 225 xp
new Array("Wrapped Bundle of Greater Fire Arrowheads","Wrapped Bundle of Arrowshafts",100),// 230 xp
new Array("Wrapped Bundle of Deadly Fire Arrowheads","Wrapped Bundle of Arrowshafts",100));// 250 xp

var GlyphSteps = new Array(
new Array("Claw Glyph","Quality Pyreal Ingot",250),
new Array("New Claw Glyph","Good Diamond Infused Pyreal Ingot",400),
new Array("New Bow Glyph","Good Diamond Infused Pyreal Ingot",400));
// new Array("New Wand Glyph","Good Diamond Infused Pyreal Ingot",400));

var CritterSteps = new Array("1","2","3");

// Lockpick Items.  These are all of the kinds of lockpicks you can get.  Go buy them.  Dont change
// anything in this loop.  Let it not find the item and examine whatever it has selected instead.
var LockpickItems = new Array(
	"Crude Lockpick",
	"Plain Lockpick", 
	"Reliable Lockpick", 
	"Good Lockpick", 
	"Excellent Lockpick", 
	"Superb Lockpick",
	"Peerless Lockpick");

// NoBurnItems.  These items do not burn when used with a full pack.  This is also used to
// attempt a step multiple times when failing (e.g. Alchy 350 skill) since you no longer
// receive XP when failing a tradeskill step, only when succeeding (July 02 patch).
var NoBurnItems = new Array(
"Mortar and Pestle", "Alembic", TonguesOrGuts, "Thin Diamond Oil","Quality Pyreal Ingot","Thick Diamond Oil",
"Heavy Grinder", "Carving Knife", "Noodle Cutter", "Baking Pan", "Cooking Pot", DyePot, ClothingItem, Sinew,
"Whittling Knife", "Barbed Fletching Tool", TypeOfUndeadBone, "Claw Glyph","New Claw Glyph","New Bow Glyph",
"New Wand Glyph");

// HowToProduce - Array: This array is a deeply nested array that allows me to build up a
// list of what to purchase (the base components) and how to make those components from
// the base components.
//
// Each main record has the goal item, which is an item I need from the tradeskill arrays above.
// The next record is an Array of all the items needed to make that goal item from scratch.
//     You will notice that for multiple step goal items (wrapped deadly fire arrowheads) that
//     Concentrated Aqua Incanta is listed 3 times in the base components list.  This ensures
//     that the program counts 3 Conc Aquas as being needed.  The only other way I could figure
//     it out would be an item and then a # to buy, this just seemed cleaner in general, especially
//     for the basic ones.
// The final record has an Array of steps needed to produce the goal item.  These steps are always
//     paired and intermediate components can be found here.
//
var HowToProduce = new Array(
// First Item: Product to make
//		Second Item: Raw Components
//				Third Item: Steps to Make Item
new Array("Chorizite Oil", 
		new Array("Chorizite"), 
				new Array("Alembic","Chorizite")), //Put in for AdHoc Reasons
new Array("Chorizite Potion",
		new Array("Ground Chorizite","Vitriol"), 
				new Array("Ground Chorizite","Vitriol")), //Put in for AdHoc Reasons
new Array("Bloodseeker Infusion", 
		new Array("Quicksilver"), 
				new Array("Alembic", "Quicksilver")),
new Array("Mana Infusion", 
		new Array("Gypsum"), 
				new Array("Alembic", "Gypsum")),
new Array("Concentrated Bloodseeker Infusion",
		new Array("Quicksilver Pea"), 
				new Array("Alembic","Quicksilver Pea")),
new Array("Concentrated Bloodhunter Infusion",
		new Array("Stibnite Pea"), 
				new Array("Alembic","Stibnite Pea")),
new Array("Victual Infusion", 
		new Array("Realgar"), 
				new Array("Alembic","Realgar")),
new Array("Bloodseeker Oil", 
		new Array("Quicksilver","Aqua Incanta"), 
				new Array("Alembic", "Quicksilver", "Bloodseeker Infusion","Aqua Incanta")),
new Array("Dough", 
		new Array("Flour", "Water"), 
				new Array("Flour","Water")),
new Array("Steak", 
		new Array("Meat"), 
				new Array("Carving Knife","Meat")),
new Array("Batter", 
		new Array("Flour","Water","Egg"), 
				new Array("Flour","Water","Dough","Egg")),
new Array("Mana Oil", 
		new Array("Gypsum","Aqua Incanta"), 
				new Array("Alembic", "Gypsum","Mana Infusion","Aqua Incanta")),
new Array("Cheese Filled Mushroom",
		new Array("Brimstone-cap Mushroom","Cheese"),
				new Array("Carving Knife","Brimstone-cap Mushroom","Stemless Mushroom","Cheese")),
new Array("Victual Oil",
		new Array("Realgar","Aqua Incanta"), 
				new Array("Alembic", "Realgar","Victual Infusion","Aqua Incanta")),
new Array("Raw Egg Noodles",
		new Array("Flour","Water","Egg"), 
				new Array("Flour","Water","Dough","Egg","Noodle Cutter","Batter")),
new Array("Ground Meat", 
		new Array("Meat"), 
				new Array("Carving Knife","Meat", "Heavy Grinder","Steak")),
new Array("Fire Oil", 
		new Array("Turpeth","Aqua Incanta"), 
				new Array("Alembic","Turpeth","Fire Infusion","Aqua Incanta")),
new Array("Bloodhunter Oil",
		new Array("Stibnite","Aqua Incanta"), 
				new Array("Alembic","Stibnite","Bloodhunter Infusion","Aqua Incanta")),
new Array("Concentrated Bloodhunter Oil",
		new Array("Stibnite Pea","Concentrated Aqua Incanta"), 
				new Array("Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion",
				"Concentrated Aqua Incanta")),
new Array("Bundle of Greater Arrowheads",
		new Array("Quicksilver","Aqua Incanta","Bundle of Arrowheads"),
				new Array("Alembic","Quicksilver","Bloodseeker Infusion","Aqua Incanta",
				"Bloodseeker Oil","Bundle of Arrowheads")),
new Array("Wrapped Bundle of Greater Arrowheads",
		new Array("Quicksilver Pea","Concentrated Aqua Incanta","Wrapped Bundle of Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil",
				"Wrapped Bundle of Arrowheads")),
new Array("Wrapped Bundle of Greater Blunt Arrowheads",
		new Array("Quicksilver Pea","Concentrated Aqua Incanta","Wrapped Bundle of Blunt Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil",
				"Wrapped Bundle of Blunt Arrowheads")),
new Array("Bundle of Greater Blunt Arrowheads",
		new Array("Quicksilver","Aqua Incanta","Bundle of Blunt Arrowheads"),
				new Array("Alembic","Quicksilver","Bloodseeker Infusion","Aqua Incanta",
				"Bloodseeker Oil","Bundle of Blunt Arrowheads")),
new Array("Bundle of Greater Frog Crotch Arrowheads",
		new Array("Quicksilver","Aqua Incanta","Bundle of Frog Crotch Arrowheads"),
				new Array("Alembic","Quicksilver","Bloodseeker Infusion","Aqua Incanta",
				"Bloodseeker Oil","Bundle of Frog Crotch Arrowheads")),
new Array("Bundle of Deadly Frog Crotch Arrowheads",
		new Array("Stibnite","Aqua Incanta","Quicksilver","Aqua Incanta", "Bundle of Frog Crotch Arrowheads"),
				new Array("Alembic","Quicksilver","Bloodseeker Infusion","Aqua Incanta",
				"Alembic","Stibnite","Bloodhunter Infusion","Aqua Incanta","Bloodseeker Oil",
				"Bundle of Frog Crotch Arrowheads","Bloodhunter Oil",
				"Bundle of Greater Frog Crotch Arrowheads")),
new Array("Wrapped Bundle of Deadly Blunt Arrowheads",
		new Array("Stibnite Pea","Concentrated Aqua Incanta","Quicksilver Pea","Concentrated Aqua Incanta",
		"Wrapped Bundle of Blunt Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil",
				"Wrapped Bundle of Blunt Arrowheads","Concentrated Bloodhunter Oil",
				"Wrapped Bundle of Greater Blunt Arrowheads")),
new Array("Wrapped Bundle of Greater Frog Crotch Arrowheads",
		new Array("Quicksilver Pea","Concentrated Aqua Incanta", "Wrapped Bundle of Frog Crotch Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil",
				"Wrapped Bundle of Frog Crotch Arrowheads")),
new Array("Bundle of Deadly Fire Arrowheads",
		new Array("Stibnite","Aqua Incanta","Quicksilver","Aqua Incanta", "Turpeth","Aqua Incanta",
		"Bundle of Arrowheads"),
				new Array("Alembic","Quicksilver","Bloodseeker Infusion","Aqua Incanta","Alembic",
				"Stibnite","Bloodhunter Infusion","Aqua Incanta","Alembic","Turpeth","Fire Infusion",
				"Aqua Incanta","Bloodseeker Oil","Bundle of Arrowheads","Fire Oil",
				"Bundle of Greater Arrowheads","Bloodhunter Oil","Bundle of Greater Fire Arrowheads")),
new Array("Wrapped Bundle of Greater Fire Arrowheads",
		new Array("Turpeth Pea","Concentrated Aqua Incanta","Quicksilver Pea","Concentrated Aqua Incanta",
		"Wrapped Bundle of Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Alembic","Turpeth Pea","Concentrated Fire Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil",
				"Wrapped Bundle of Arrowheads","Concentrated Fire Oil",
				"Wrapped Bundle of Greater Arrowheads")),
new Array("Wrapped Bundle of Deadly Fire Arrowheads",
		new Array("Turpeth Pea","Concentrated Aqua Incanta","Quicksilver Pea","Concentrated Aqua Incanta",
		"Stibnite Pea","Concentrated Aqua Incanta","Wrapped Bundle of Arrowheads"),
				new Array("Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion",
				"Concentrated Aqua Incanta","Alembic","Turpeth Pea","Concentrated Fire Infusion",
				"Concentrated Aqua Incanta","Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion",
				"Concentrated Aqua Incanta","Concentrated Bloodseeker Oil","Wrapped Bundle of Arrowheads",
				"Concentrated Fire Oil","Wrapped Bundle of Greater Arrowheads",
				"Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Fire Arrowheads")),
new Array("Wrapped Bundle of Deadly Acid Arrowheads",
		new Array("Brimstone Pea","Quicksilver Pea","Stibnite Pea","Concentrated Aqua Incanta",
		"Concentrated Aqua Incanta","Concentrated Aqua Incanta","Wrapped Bundle of Arrowheads"),
				new Array(
				"Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion","Concentrated Aqua Incanta",
				"Alembic","Brimstone Pea","Concentrated Acid Infusion","Concentrated Aqua Incanta",
				"Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion","Concentrated Aqua Incanta",
				"Concentrated Bloodseeker Oil","Wrapped Bundle of Arrowheads",
		  		"Concentrated Acid Oil","Wrapped Bundle of Greater Arrowheads",
		  		"Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Acid Arrowheads")),
new Array("Wrapped Bundle of Deadly Frost Arrowheads",
		new Array("Colcothar Pea","Stibnite Pea","Quicksilver Pea","Concentrated Aqua Incanta",
		"Concentrated Aqua Incanta","Concentrated Aqua Incanta","Wrapped Bundle of Arrowheads"),
				new Array(
				"Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion","Concentrated Aqua Incanta",
		  		"Alembic","Colcothar Pea","Concentrated Frost Infusion","Concentrated Aqua Incanta",
		  		"Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion","Concentrated Aqua Incanta",
		  		"Concentrated Bloodseeker Oil","Wrapped Bundle of Arrowheads",
		  		"Concentrated Frost Oil","Wrapped Bundle of Greater Arrowheads",
		  		"Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Frost Arrowheads")),
new Array("Wrapped Bundle of Deadly Lightning Arrowheads",
		new Array("Cobalt Pea","Stibnite Pea","Quicksilver Pea","Concentrated Aqua Incanta",
		"Concentrated Aqua Incanta","Concentrated Aqua Incanta","Wrapped Bundle of Arrowheads"),
				new Array(
				"Alembic","Quicksilver Pea","Concentrated Bloodseeker Infusion","Concentrated Aqua Incanta",
		  		"Alembic","Cobalt Pea","Concentrated Lightning Infusion","Concentrated Aqua Incanta",
		  		"Alembic","Stibnite Pea","Concentrated Bloodhunter Infusion","Concentrated Aqua Incanta",
		  		"Concentrated Bloodseeker Oil","Wrapped Bundle of Arrowheads",
		  		"Concentrated Lightning Oil","Wrapped Bundle of Greater Arrowheads",
		  		"Concentrated Bloodhunter Oil","Wrapped Bundle of Greater Lightning Arrowheads"))
);



// ----------------------------------------------------------------
// There's nothing to see... Move along people
//
// You're done making changes, the rest is all automatic :).
// ----------------------------------------------------------------
// My set of timers:
var AlchemyTimer = skapi.TimerNew();
var AlchemyTimerMin = 130000;
AlchemyTimer.cmsec = AlchemyTimerMin;  //Set them to full so the first loop runs immediately.
var CookingTimer = skapi.TimerNew();
var CookingTimerMin = 130000;
CookingTimer.cmsec = CookingTimerMin;
var FletchingTimer = skapi.TimerNew();
var FletchingTimerMin = 130000;
FletchingTimer.cmsec = FletchingTimerMin;
var LockpickTimer = skapi.TimerNew();
var LockpickTimerMin = 130000;
LockpickTimer.cmsec = LockpickTimerMin; 
var GlyphTimer = skapi.TimerNew();
var GlyphTimerMin = 130*1000*2;
GlyphTimer.cmsec = GlyphTimerMin;
var CritterTimer = skapi.TimerNew();
var CritterTimerMin = 130*1000*2;
CritterTimer.cmsec = CritterTimerMin;


// Used to ensure you have a running log of performance on burnt items.
var ReportTimer = skapi.TimerNew();
var ReportTimerMax = 60 * 60 * 1000;  // 60 mins * 60 Secs * 1000 msec
// Every 5 minutes, spout off to your fellowship that you're still alive... could be 10, but doesnt
// really take any time.
var KeepLoggedInTimer = skapi.TimerNew();
var KeepLoggedInTimerMax = 5 * 60 * 1000;
// Keep track of Total XP earned
var XPTimer = skapi.TimerNew();
var StartXP = 0;
var CurrentXP = 0;
var mainpack = skapi.acoChar;
var item1;
var item2;
var hACF = new MyACFHandlers();
// A whole bunch of arrays defined to be global so I can play with them.
var InventoryList = new Array;
var MissingList = new Array;
var ProductionList = new Array;
var PurchaseList = new Array;
var PrepCommands = new Array;
// InProgress is designed to allow someone to abort out of any code section back
// to the main waiting area.
var InProgress = false;
var NewCommand = "";
var ACOAdd;
var Pause = false;
// Keep track of XP earned in each skill
var XPEarned = new Array();
// Used to show success when multiple attempts occur on no burn items
var SkillStat;

// =========== EVENTS ===================================
function MyACFHandlers()
{
	this.OnStatSkillExp = MyACFHandlers_OnStatSkillExp;
	this.OnTellFellowship = MyACFHandlers_OnTellFellowship;
	this.OnAddToInventory = MyACFHandlers_OnAddToInventory;
	this.OnCommand = MyACFHandlers_OnCommand;
}

function MyACFHandlers_OnCommand(szCmd)
{
	NewCommand = szCmd.toLowerCase();
	if (NewCommand == "stop") {InProgress = false}
	else if (NewCommand == "xp") {fPrintXP(); NewCommand = null}
	else if (NewCommand == "report") {fPrintReport(); NewCommand = null}
	else if (NewCommand == "unp") {pause = false; NewCommand = null}
	else if (NewCommand == "p") {pause = true; while (pause) {skapi.WaitEvent(100,3)}}
}

// On Stat Skill Exp:  Did you earn XP towards a skill?  If its the first time, create a new
// array with its name and total XP.  If it exists, update the last slot with the new total.
// Also, mark SkillStat as true (you've earned XP in a skill).
function MyACFHandlers_OnStatSkillExp(skid, szSkill, diff, expTotal, dsklvl)
{
	if (!XPEarned[skid]) {XPEarned[skid] = new Array(szSkill, expTotal, expTotal);rSay(skid+" added")}
	else {XPEarned[skid][2] = expTotal}
	SkillStat=true
//    sSay("OnStatSkillExp: "+szSkill+" ("+skid+") just went up on a "+diff+" difficulty task.  You're up "+dsklvl+" levels in that skill.");
}

// Fellowship tells:  Immediate action tells are "stop" to set InProgress to false (abort a section),
// XP to report current XP earned, Report to report Inventory issues, "p" pauses operation (traps the
// macro in the event) until "unp" is received (releases the event.  This may cause a minor recursion, but
// I've never had it be a problem.
function MyACFHandlers_OnTellFellowship(szSender, szMsg)
{	
	if (szMsg.toLowerCase() == "stop") {InProgress = false}
	else if (szMsg.toLowerCase() == "xp") {fPrintXP(); NewCommand = null}
	else if (szMsg.toLowerCase() == "report") {fPrintReport(); NewCommand = null}
	else if (szMsg.toLowerCase() == "unp") {pause = false; NewCommand = null}
	else if (szMsg.toLowerCase() == "p") {pause = true; while (pause) {skapi.WaitEvent(100,3)}}
}

// On Add To Inventory - Just set up to pass the ACO for the makeprep portion.
function MyACFHandlers_OnAddToInventory(aco)
{	ACOAdd = aco;
	// sSay("Add to Inventory: "+aco.szName);
}

// ===================Reports==============================

// Reporting Function - XP Earned, total and per skill.
function fPrintXP()
{
	var TotalXP 	= (skapi.expTotal - StartXP);
	var Hours 	= (Math.round(XPTimer.cmsec/1000/60/60*100))/100;

	var String1 = "Current XP Earned is " + TotalXP + " at " + (TotalXP/Hours).toFixed(2) + " XP/Hr in "+Hours+" Hrs ";	
	var String2 = "";
	skapi.OutputLine("/f " + String1);
	for (var zz=0; zz<skidMax; zz++)
	{	if (XPEarned[zz]) 
		{	
			var xp = XPEarned[zz][2] - XPEarned[zz][1];
			var hourly = (xp/Hours).toFixed(0);
			var text = (XPEarned[zz][0]+": "+xp+" @ "+hourly+"/hr");
			sSay(text);
		}
	}
	skapi.OutputLine("/f done");

}

// Print Report - Writes to a file the burn rate of your components...
function fPrintReport()
{	var Hours, Burnt, Hourly, Daily, Weekly
	var fso, tf, dt
	fso = new ActiveXObject("Scripting.FileSystemObject");
	tf = null;
	dt = new Date
	Hours = (Math.round(XPTimer.cmsec/1000/60/60*100))/100;
	tf = fso.OpenTextFile(tfBurnedComps, 8, true);
	rSay("Missing Items at Start were:");
	for (var x = 0; x<MissingList.length; x++) {rSay(MissingList[x])}
	for (var x = 0; x<InventoryList.length; x++)
	{	InventoryList[x][3] = skapi.CitemOfKindInInv(InventoryList[x][0]);
		Burnt = InventoryList[x][2] - InventoryList[x][3]
		Hourly = Burnt/Hours;
		Daily = Burnt/Hours*24;
		Weekly = Daily * 7;
		var ctry = 0;
		var ItemName
		if (!InventoryList[x][3]) {ItemName = (InventoryList[x][0]+"*"); rSay("Out of "+ItemName)}
		else {ItemName = InventoryList[x][0]}
		if (!Burnt) {skapi.WaitEvent(100)}
		else
		{	sSay("Burnt:" +Burnt+" "+ItemName+" or "+Hourly.toFixed(2)+" per hr, "+Daily.toFixed(2)+" per day, "+Weekly.toFixed(2)+" per week.");
			while (true)
			{
			    try
				{
				tf.WriteLine(dt+": in "+Hours+" hrs I burnt "+Burnt+" "+ItemName+" or "+Hourly+"/hr, "+Daily+"/day, "+Weekly+"/wk");
				break;  // Success; exit the loop.
				}
			    catch (e)
				{
				ctry++;
				if (ctry == 3) throw e;  // Failed three times; bail.
				skapi.Sleep(100);  // Wait a bit before trying again.
				}
		}	 } 
	}
	tf.Close();
}

// =========================Inventory Management=====================================		

// Fill the pack with BS Infusions, or Arrows, or Applesauce...
// This is called only if the mainpack is < 102
function fFillPack()
{
	while (mainpack.citemContents < 102)
	{	sSay(AlchemySteps[0][0] +" on "+AlchemySteps[0][1]);
		item1 = skapi.AcoFindInInv(AlchemySteps[1][0]);
		item2 = skapi.AcoFindInInv(AlchemySteps[1][1]);
		if ((!item1) || (!item2)) 
		{	sSay ("Items are missing from inventory, skipping step.");
			break;
		}
		else 
		{	item1.UseOnAco(item2);
			skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
		}	
	}
	if (!InProgress) {return}
	while (mainpack.citemContents < 102)
	{	item1 = skapi.AcoFindInInv(FletchingSteps[0][0]);
		item2 = skapi.AcoFindInInv(FletchingSteps[0][1]);
		if ((!item1) || (!item2)) 
		{	sSay ("Items are missing from inventory, skipping step.");
			break;
		}
		else 
		{	item1.UseOnAco(item2);
			skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
		}	
	}
	if (!InProgress) {return}
	while (mainpack.citemContents < 102)
	{	item1 = skapi.AcoFindInInv(CookingSteps[0][0]);
		item2 = skapi.AcoFindInInv(CookingSteps[0][1]);
		if ((!item1) || (!item2)) 
		{	sSay ("Items are missing from inventory, skipping step.");
			break;
		}
		else 
		{	item1.UseOnAco(item2);
			skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
		}	
	}
}

// fBuildInventory(Array):  Based on the contents of the array, define starting #'s for
// each component.  This is mainly to create a list of the Items, the # that should be
// in stock based on defined stocking levels, and how many really are in inventory.
function fBuildInventory(SkillGroup)
{
	var x,y,z,InStock;
	var match = false;
	var ill=InventoryList.length;
	var mll=MissingList.length

	for (x=0; x<SkillGroup.length; x++)
	{	for (y=0; y<(SkillGroup[x].length-1); y++)
		{	
			InStock = skapi.CitemOfKindInInv(SkillGroup[x][y]);
			skapi.WaitEvent(0);
			match = false;
			for (z=0; z<ill; z++)
			{	// sSay("Does: "+SkillGroup[x][y]+" == "+InventoryList[z][0]);
				if (SkillGroup[x][y] == InventoryList[z][0])
				{	InventoryList[z][1] += SkillGroup[x][2];
					// sSay("Inventory update: "+InventoryList[z][0]+" is now "+InventoryList[z][1]);
					match = true;
				}
			}
			if (!match)
			{	InventoryList[ill]=new Array(SkillGroup[x][y],SkillGroup[x][2],InStock);
				// sSay(SkillGroup[x][y]+" added to the inventory list.");
				ill++;
			}
			skapi.WaitEvent(0);
			// I dont believe the code below executes anymore, but I'm commenting this
			// w/o AC around, so I'll not delete it just yet. (if (!ill))
			if (!ill) 
			{	sSay("First Item");
				InventoryList[ill]=new Array(SkillGroup[x][y],SkillGroup[x][2], InStock);
				ill++;
			}
		}
	}
}

// fBuildMissingList(): A relic to an extent, but made spouting off about what was missing easier
// so I left it and defined it a new way, defined it based on inventory = 0.  Previous versions had
// zero inventory items eliminated from the inventory list and only stored in the Missing List.
function fBuildMissingList()
{	sSay("Building Missing Items List");
	for (var x=0; x<InventoryList.length; x++)
	{	// sSay("Inventory: "+InventoryList[x][0]+", "+InventoryList[x][1]+", "+InventoryList[x][2]);
		// skapi.WaitEvent(250,3);
		if (!InventoryList[x][2]) {MissingList.push(InventoryList[x][0])}
	}
}

// fBuildProductionFile():  This is essentially an inventory report showing what items you need to
// go buy (completed items that is).  It pushes the same info into an Array (ProductionList) to drive
// the Production of prep components.  It places the requirements in plain english for a purchaser, but
// the same information is also contained in a second file, so it may be redundant.
// 
// Logic: Evaluate the Inventory List.  If you have more inventory than needed, skip that item and
//        dont write to file.  If you have less than needed, see if its a NoBurn item.  If so, if
//        one exists in inventory, dont write it, you've got plenty.
//
function fBuildProductionFile()
{	var fso, tf, dt, a;
	fso = new ActiveXObject("Scripting.FileSystemObject");
	tf = null;
	var ctry = 0;
	tf = fso.OpenTextFile(tfRestockItems, 2, true);  // 1 read, 2 write, 8 append
	for (a=0; a<InventoryList.length; a++)
	{	// sSay("Inventory: "+InventoryList[a][0]+", "+InventoryList[a][1]+", "+InventoryList[a][2]);
		var ItemName = InventoryList[a][0];
		var ToBuy = Math.max((InventoryList[a][1] - InventoryList[a][2]), 0);
		if (ToBuy)
		{	for (var y = 0; y<NoBurnItems.length; y++)
			{	if (ItemName == NoBurnItems[y]) 
				{	// rSay(ItemName+" ToBuy was "+ToBuy);
					if (skapi.CitemOfKindInInv(ItemName)) {ToBuy = 0}
					else {ToBuy = 1};
					// gSay(ItemName+" ToBuy Is now "+ToBuy)
				}
			}
		}
		var text = "You need to buy "+ToBuy+" "+ItemName+"(s).";
		// sSay("Opening File");
	     try
		{	if (ToBuy) 
			{	tf.WriteLine(text);
				// gSay(text)
				ProductionList.push(new Array(ItemName, ToBuy));
			}
			
		}
	    catch (e)
		{	ctry++
			sSay("Write Failure");
			if (ctry == 3) throw e;  // Failed three times; bail.
			skapi.Sleep(100);  // Wait a bit before trying again.
		}
		ctry = 0;
	}
	tf.Close();
}

// fBuildPurchaseFile():  This got long and stringy quickly.  Designed to go through the production list
// that we created above (Finished Item Name, how many to buy) and review to determine base components
// to purchase and steps to complete the task.
// 
// Due to length, logic will be placed in-line
function fBuildPurchaseFile()
{	var fso, tf, tf2, dt, a,b,c,x;
	fso = new ActiveXObject("Scripting.FileSystemObject");
	tf = null;
	var ctry = 0;
	var match = false;
	var TempPurchase = new Array;
	// Logic: Compare the Production list item to the HowToProduce array to see if it exists in
	//        that array.  If it does, then look at the middle record (the array of base components)
	//        and create a purchase list of those items and how many needed.
	//        Then, look at the last record (the array of steps to make), and add those to an array
	//        of steps.  This is a leftover loop and file that's interesting to look at (I kept it
	//        for the file it writes, but I now use just the production list to do the steps later).
	for (a=0; a<ProductionList.length; a++)
	{	for (b=0; b<HowToProduce.length; b++)
		{	if (ProductionList[a][0] == HowToProduce[b][0])
			{	for (c=0; c<HowToProduce[b][1].length; c++)
				{	TempPurchase.push(new Array(HowToProduce[b][1][c], ProductionList[a][1]))
					match = true;
				}
				for (c=0; c<HowToProduce[b][2].length; c=c+2)
				{	PrepCommands.push(new Array(HowToProduce[b][2][c],HowToProduce[b][2][c+1],ProductionList[a][1]))
				}
			}
		}
		if (!match) {TempPurchase.push(new Array(ProductionList[a][0], ProductionList[a][1]))}
		match = false;
	}
	// Logic: I didnt worry about having multiple purchase items for the purchase list, it seemed
	//        neater to clean them up here instead of above.  This just looks at the TempPurchase
	//        array and consolidates multiples (e.g. all those Concentrated Aqua Incantas) into
	//        one purchase array.
	for (x=0; x<TempPurchase.length; x++)
	{	match = false;
		for (var z=0; z<PurchaseList.length; z++)
		{	if (TempPurchase[x][0] == PurchaseList[z][0])
			{	PurchaseList[z][1] += TempPurchase[x][1];
				match = true;
			}
		}
		if (!match)
		{	PurchaseList.push(new Array(TempPurchase[x][0],TempPurchase[x][1]))
		}
	}
	sSay("End of Build Purchase Lists - Now Writing");
	// Logic - Write out those Prep Commands for review... while not used directly
	//         until I get around to the exporting and importing of activity lists,
	//	   Its a nice review file.
	tf = fso.OpenTextFile(tfPrepCommands, 2, true);  // 1 read, 2 write, 8 append
	sSay("Opening File");
	for (x=0; x<PrepCommands.length; x++)
	{	var text = PrepCommands[x][0]+", "+PrepCommands[x][1]+", "+PrepCommands[x][2];
		// sSay("Opening File");
	     try
		{	tf.WriteLine(text);
			// gSay(text)
		}
	    catch (e)
		{	ctry++
			rSay("Write Failure");
			if (ctry == 3) throw e;  // Failed three times; bail.
			skapi.Sleep(100);  // Wait a bit before trying again.
		}
		ctry = 0;
	}
	tf.Close();
	
	// Logic: OK, write out that purchase list of raw components...  Oh wait, before you do that,
	//        take a look at your inventory.  Do you have more inventory than you need for stocking?
	//        If so, you can use that to reduce the amount you need to buy.  OK, now write it.
	for (var q=0; q<PurchaseList.length; q++)
	{	var match=false;
		for (var r=0; r<InventoryList.length; r++)
		{	
			if (PurchaseList[q][0] == InventoryList[r][0])
			{	// sSay("Does "+PurchaseList[q][0]+" == "+InventoryList[r][0]+", Stocking = "+InventoryList[r][1]+" and instock="+skapi.CitemOfKindInInv(PurchaseList[q][0]));
				gSay(PurchaseList[q][0] +" was "+PurchaseList[q][1]+", Inventory was "+InventoryList[r][1]+", instock:"+skapi.CitemOfKindInInv(PurchaseList[q][0]));
				PurchaseList[q][1] -= Math.max((skapi.CitemOfKindInInv(PurchaseList[q][0]) - InventoryList[r][1]), 0)
				match = true;
				break;
			}
		}
		if (!match) {PurchaseList[q][1] -= skapi.CitemOfKindInInv(PurchaseList[q][0])}
	}
	
	tf = fso.OpenTextFile(tfRawPurchases, 2, true);
	for (y=0; y<PurchaseList.length; y++)
	{	var text = "Purchase: "+PurchaseList[y][0]+", "+PurchaseList[y][1];
		// sSay("Opening File");
	     try
		{	if (PurchaseList[y][1] > 0)
			{	tf.WriteLine(text);
			}
			// rSay(text)
		}
	    catch (e)
		{	ctry++
			rSay("Write Failure");
			if (ctry == 3) throw e;  // Failed three times; bail.
			skapi.Sleep(100);  // Wait a bit before trying again.
		}
		ctry = 0;
	}
	tf.Close();
}

// ===========================  Actual Activities =============================

// doLoop(TradeSkillLoop):  Hey, its the function that started it all.  Give us some nice
// text to tell the end user what we're doing.  Then check to see if both items are in stock.
// OK, now if they're both in stock, we need to apply some logic.
//
// Logic: We only get XP now on successful attempts.  But we dont want to burn the heck out
//        of our comps, so if you're on a step with a no-burn item, try it until you either
//        earn XP from the step, or you've tried it 5 times.  Yes, this does mean that I'd
//        burn 5 QS Peas if I couldnt get a 50 skill level done, but that should be rare.
// 	  If it doesnt have a no-burn item, just do it once, we'll burn enough w/o trying it
//        five times.
function doLoop(TradeSkillLoop)
{	
	for (var x=0; x<TradeSkillLoop.length; x++)
	{	
		sSay("=====  "+TradeSkillLoop[x][0] +" on "+TradeSkillLoop[x][1] +"  =====");
		item1 = skapi.AcoFindInInv(TradeSkillLoop[x][0]);
		if (!item1) {sSay(TradeSkillLoop[x][0] + " missing from inventory, skipping step")}
	
		item2 = skapi.AcoFindInInv(TradeSkillLoop[x][1]);
		if (!item2) {sSay(TradeSkillLoop[x][1] + " is missing from inventory, skipping step")}
		
		skapi.WaitEvent(0);
		var z=0
		var match = false;
		SkillStat=false;
		if ((item1) && (item2))
		{	for (var y=0; y<NoBurnItems.length; y++)
			{	if ((item1.szName == NoBurnItems[y]) || (item2.szName == NoBurnItems[y]))
				{	// sSay("NoBurn Match");
					match = true;
					while(!SkillStat)
					{	z++
						item1.UseOnAco(item2);
						skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
						if (z>4) {break}
					}
				}
				if (match) {break}
			}
			if (!match) 
			{	item1.UseOnAco(item2);
				skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
			}
		}
		skapi.WaitEvent(0);
	}

}

// fID(ItemsList):  It appears only lockpick is left as the last ID it and get XP skill.
// Healkits died in May 02 patch apparently.  This code really is untested, I've not got
// a lockpick on my toon, but it should work...
function fID(ItemsList)
{
	for (var x=0; x<ItemsList.length; x++)
	{	item1 = skapi.AcoFindInInv(ItemsList[x]);
		if (item1) 
		{	skapi.SelectAco(item1);
			skapi.WaitEvent(100,3);
			skapi.Keys("e");
			skapi.WaitEvent(300,3);
			skapi.Keys(cmidInventoryPanel)
			skapi.WaitEvent(100,3);
		}
	}
}


// rSay, gSay: Hey, lets have some nice colors...
function rSay(text) {	skapi.OutputLine(text,opmChatWnd | opmConsole,cmcRed)}
function gSay(text) {	skapi.OutputLine(text,opmChatWnd | opmConsole,cmcGreen)}

// fEarnXP: This is a mainloop for earning XP.  Just keep looping and checking
// for a full main pack.  Start the loop, report the time, and relax.
// 
// Future Additions: Weapon skills (Glyphs on ingots, puzzle pieces, etc).
//		     should be pretty easy, just add an array above with a type variable.
function fEarnXP()
{	InProgress = true;
	while (!skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
	skapi.Keys("^{PgUp}"); skapi.WaitEvent(1000,3);
	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
	while (InProgress)
	{	var dt = new Date();
		if ((CritterExists) && 
		    (skapi.manaCur > 150) && 
		    (CritterTimer.cmsec > CritterTimerMin) &&
		    (skapi.CitemOfKindInInv("Prismatic Taper") > 10))
			{	rSay(dt+"  ********** Starting Critter Loop @ "+CritterTimer.cmsec+" **********");
				while (!skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				for (var x = 0; x < CritterSteps.length; x++)
				{	skapi.Keys(CritterSteps[x]);
					var WtTime = (3000+(1000*x));
					skapi.WaitEvent(WtTime,3);
				}
				CritterTimer.cmsec = 0;
				while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				sSay("Critter Done");
			}	
		if ((AlchemyExists) && (AlchemyTimer.cmsec > AlchemyTimerMin))
			{	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				if (mainpack.citemContents < 102) 
				{	sSay("/f "+mainpack.citemContents+" items in mainpack >= 102");
					fFillPack()
				}
				if (mainpack.citemContents < 102) {skapi.WaitEvent(100)}
				else 
				{	rSay(dt+"  ********** Starting Alchy Loop @ "+AlchemyTimer.cmsec+" **********");
					doLoop(AlchemySteps);
				}
				AlchemyTimer.cmsec = 0;
			}
		skapi.WaitEvent(0);
		if ((FletchingExists) && (FletchingTimer.cmsec > FletchingTimerMin))
			{	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				if (mainpack.citemContents < 102) 
				{	sSay("/f "+mainpack.citemContents+" items in mainpack >= 102");
					fFillPack()
				}
				if (mainpack.citemContents < 102) {skapi.WaitEvent(100)}
				else 
				{	rSay(dt+"  ********** Starting Fletching Loop @ "+FletchingTimer.cmsec+" **********");
					doLoop(FletchingSteps);
				}
				FletchingTimer.cmsec = 0;
			}
		skapi.WaitEvent(0);
		if ((CookingExists) && (CookingTimer.cmsec > CookingTimerMin))
			{	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				if (mainpack.citemContents < 102) 
				{	rSay("/f "+mainpack.citemContents+" items in mainpack >= 102");
					fFillPack()
				}
				if (mainpack.citemContents < 102) {skapi.WaitEvent(100)}
				else 
				{	rSay(dt+"  ********** Starting Cooking Loop @ "+CookingTimer.cmsec+" **********");
					doLoop(CookingSteps);
				}
				CookingTimer.cmsec = 0;
			}
		skapi.WaitEvent(0);
		if ((LockpickExists) && (LockpickTimer.cmsec > LockpickTimerMin))
			{	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				sSay("/f "+dt+"   **********  Starting Lockpick ID Loop @ "+LockpickTimer.cmsec+" **********");
				fID(LockpickItems); LockpickTimer.cmsec = 0
				
				sSay("Lockpick ID Done");
			}
		if ((GlyphExists) && (GlyphTimer.cmsec > GlyphTimerMin))
			{	while (skapi.fCombatMode) {skapi.Keys("~"); skapi.WaitEvent(3000,3)}
				if (mainpack.citemContents < 102) 
				{	rSay("/f "+mainpack.citemContents+" items in mainpack <= 102");
					fFillPack()
				}
				if (mainpack.citemContents < 102) {skapi.WaitEvent(100)}
				else 
				{	rSay(dt+"  ********** Starting Glyph Loop @ "+GlyphTimer.cmsec+" **********");
					doLoop(GlyphSteps);
				}
				GlyphTimer.cmsec = 0;
				sSay("Glyph Done");
			}	

		skapi.WaitEvent(0);
		fCheckTimers();
		if (SpouseAbort) {fCheckSpouse()}
	}
	sSay("Processing has stopped for the XP Earning Loop");
}

// fMakePrep(): Main Section for the make prep portion.  PrepFile Must have been run before this or
// all of the arrays are blank (which makes it process really really quickly).
//
// Logic: Take a look at the production list  Compare those items to the HowToProduce array.  If there's
//        a match, look to the 3rd slot in HowToProduce and start running through those steps.  Oh, and
//        do them the # of times shown in the production list.  The c=c+2 is because you're always doing
//	  them in groups of 2.  Once you've started, when you've combined 2 items, stack it.  Its not
//	  perfect, but we're only trying to minimize the slots used.
//        If there's not a match between an item and how to make it, tell the user to go buy that item
//        from the store.  A good example is a mana draught.  I chose not to allow that to be automated
//        due to the need to manage mana while producing those items.
function fMakePrep()
{	var match=false;
	skapi.AddHandler(evidOnAddToInventory,hACF);
	InProgress = true;
	for (var a=0; a<ProductionList.length; a++)
	{	if (!InProgress) {break}
		sSay("===== I need to make "+ProductionList[a][1]+" "+ProductionList[a][0]+"(s). =====");
		for (var b = 0; b<HowToProduce.length; b++)
		{	if (ProductionList[a][0] == HowToProduce[b][0])
			{	for (var c=0; c<HowToProduce[b][2].length; c=c+2)
				{	match = true;
					sSay("Using "+HowToProduce[b][2][c]+" on "+HowToProduce[b][2][c+1]+", "+ProductionList[a][1]+" times.");
					for (var y = 0; y<ProductionList[a][1]; y++)
					{	if (!InProgress) {break}
						item1 = skapi.AcoFindInInv(HowToProduce[b][2][c]);
						if (!item1) {sSay(HowToProduce[b][2][c]+ " missing from inventory, skipping step")}

						item2 = skapi.AcoFindInInv(HowToProduce[b][2][c+1]);
						if (!item2) {sSay(HowToProduce[b][2][c+1]+ " missing from inventory, skipping step")}
						skapi.WaitEvent(0);
						if ((item1) && (item2))
						{	item1.UseOnAco(item2);
							skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
							skapi.WaitEvent(500,wemSpecific,evidOnAddToInventory);
							// sSay("ACOAdd Name = "+ ACOAdd.szName);
							ACOAdd.MoveToPack(0, 0, true); 
							skapi.WaitEvent(500,wemSpecific,evidOnAddToInventory)
						}
						skapi.WaitEvent(100,3);
					}
				fCheckTimers();
				}
			}
		}
		if (!match) {rSay("Please go purchase the item, I dont know how to make it from scratch.")}
		match = false;
	}
}

function fAdHoc()
{	var AdHocArray = new Array();
	skapi.AddHandler(evidOnAddToInventory,hACF);
	InProgress = true;
	sSay("Welcome to Ad Hoc Processing.  Command format is:  ###, ProductToMake. 'stop' to stop & exit ad hoc");
	sSay("Commands will be validated and placed in an array.  'process' will run the array");
	sSay("'list' will list the ad hoc array, 'remove' will remove the last item from the array");
	sSay("'command' will list all the items I know how to make.");
	while (InProgress)
	{	if (skapi.WaitEvent(10000, wemSpecific, evidOnCommand) == evidOnCommand)
		{	switch (NewCommand)
			{
			case "command":
			case "commands":
				sSay("I know how to make:");
				var cListOfCommands = "";
				var each = Math.floor(HowToProduce.length/5) + 1;
				for (var e=0; e<each; e++)
				{
					for (var i=0; i < 5; i++)
					{	
						var add = e*5+i
						if (add >= HowToProduce.length) {break}
						cListOfCommands = cListOfCommands + HowToProduce[add][0] + ", ";
					}
					sSay(cListOfCommands);
					skapi.WaitEvent(0);
					cListOfCommands = "";
				}
				break;
			case "list":
				for (var a=0; a<AdHocArray.length; a++)
				{	sSay("AdHoc["+a+"] = "+AdHocArray[a][0]+" "+HowToProduce[(AdHocArray[a][1])][0]);
				}
				break;
			case "remove":
				AdHocArray.pop();
				break;
			case "process":
				for (var a=0; a<AdHocArray.length; a++)
				{	var qty = AdHocArray[a][0];
					var loc = AdHocArray[a][1];
					sSay("Making "+qty+" "+HowToProduce[loc][0]);
					for (var c=0; c<HowToProduce[loc][2].length; c=c+2)
					{ 	for (var x=0; x<qty; x++)
						{	if (!InProgress) {break}
							var item1 = skapi.AcoFindInInv(HowToProduce[loc][2][c]);
							var item2 = skapi.AcoFindInInv(HowToProduce[loc][2][c+1]);
							if ((item1) && (item2))
							{	item1.UseOnAco(item2);
								skapi.WaitEvent(3000,wemSpecific,evidOnActionComplete);
								skapi.WaitEvent(500,wemSpecific,evidOnAddToInventory);
								//sSay("ACOAdd Name = "+ ACOAdd.szName);
								ACOAdd.MoveToPack(0, 0, true); 
								skapi.WaitEvent(500,wemSpecific,evidOnAddToInventory)
							}
							else 
							{	if (item1) {sSay("Item 1 ok")}
								if (item2) {sSay("Item 2 ok")}
								sSay("An Item was missing, skipping step"); break
							}
							skapi.WaitEvent(100,3);
							fCheckTimers();
						}
					}
				}
				break;
			case "stop":
			case "report":
				break;
			default:
				var match = false;	
				sSay("Ad Hoc Command Received: "+NewCommand);
				var ts = NewCommand.split(", ");
				var num = parseInt(ts[0]); var FinalProduct = ts[1]; var Item1 = ts[2]; var Item2 = ts[3];
				for (var b=0; b<HowToProduce.length; b++)
				{	// sSay("Does "+FinalProduct+" == "+HowToProduce[b][0].toLowerCase());
					if (FinalProduct == HowToProduce[b][0].toLowerCase())
					{	AdHocArray.push(new Array(ts[0],b))
						match = true;
						sSay("Match");
					}
				}
				if (!match) 
				{	sSay("I was unable to determine how to make "+FinalProduct+", please ask again.");
				}
				break;
			}
		}
	}
	skapi.RemoveHandler(evidOnAddToInventory,hACF);
}

				
			
function fCheckTimers()
{
	if (KeepLoggedInTimer.cmsec > KeepLoggedInTimerMax) 
	{	skapi.WaitEvent(500,3);
		fSay("/f just keeping myself logged in.");
		KeepLoggedInTimer.cmsec = 0; 
		skapi.WaitEvent(500,3);
	}
	if (ReportTimer.cmsec > ReportTimerMax) 
	{	fSay("/t "+BuffBotName+", "+BuffBotCommand);
		fSay("/f report"); // request a report.
		ReportTimer.cmsec = 0
	}
}

// fInventorySummary():  This section reports stocking levels vs inventory.  An interesting FYI, but
// not all that useful in terms of the RestockList...  In fact, this old code should be merged into
// the RestockList I write (though I'd have to have a section for items that didnt need to be restocked)
function fInventorySummary()
{
	var fso, tf, dt
	fso = new ActiveXObject("Scripting.FileSystemObject");
	tf = null;
	dt = new Date
	tf = fso.OpenTextFile(tfInventoryList, 8, true);
	rSay("Missing Items at Start were:");
	for (var x = 0; x<MissingList.length; x++) {rSay(MissingList[x])}
	for (var x = 0; x<InventoryList.length; x++)
	{	InventoryList[x][2] = skapi.CitemOfKindInInv(InventoryList[x][0]);
		Burnt = InventoryList[x][1] - InventoryList[x][2]
		var ctry = 0;
		var ItemName
		if (!InventoryList[x][2]) {ItemName = (InventoryList[x][0]+"*"); rSay("Out of "+ItemName)}
		else {ItemName = InventoryList[x][0]}
		var text = "Stocking Level: "+InventoryList[x][1]+" "+ItemName+", we have "+InventoryList[x][2]+" or "+Burnt+" from budget.";
		sSay(text);
			while (true)
			{
			    try
				{
				ctry++;
				tf.WriteLine(text);
				break;  // Success; exit the loop.
				}
			    catch (e)
				{
				if (ctry == 3) throw e;  // Failed three times; bail.
				skapi.Sleep(100);  // Wait a bit before trying again.
				}
	}	 } 
	tf.Close();
}	

// fFillPack(): Woah, an oldie code snippet from ACTool redone for Skunkworks.  This code requires
// a stack of pyreals in slot 0, a non-splittable item in slot 1.  Splits the pyreal by 1, moves the
// one to slot 1, then takes the item in slot 2 (previously in slot 1) and moves it back to slot 1.
// repeat until full.  Timed out slow due to instability, though I think I just found the problem,
// no delay after splitting the item.  Added delay in this comment cycle, you may want to speed up
// the fPause delay
function fFillPack()
{	InProgress = true;
	while (InProgress)
	{	
		skapi.WaitEvent(3000,3);
		var mainpack = skapi.acoChar;
		if (mainpack.citemContents < 102)
		{	fGotoPackSlot(0,0);
			skapi.MouseButton(ibuttonLeft, kmoClick);
			skapi.Keys("t");
			skapi.WaitEvent(200,3);
			skapi.Keys("1");
			fPause();
			skapi.MouseButton(ibuttonLeft, kmoDown);
			fPause();
			fGotoPackSlot(1,0);
			fPause();
			skapi.MouseButton(ibuttonLeft, kmoUp);
			fServerPause();
			fGotoPackSlot(2,0);
			skapi.MouseButton(ibuttonLeft, kmoDown);
			fPause();
			fGotoPackSlot(1,0);
			fPause();
			skapi.MouseButton(ibuttonLeft, kmoUp);
			fServerPause();
		}
		if (mainpack.citemContents == 102) {InProgress = false}
	}
}
// Duplicated from ACScriptlib.js - I included acscriptlib just in case...
function fGotoPackSlot(column, row)
{
	column--; 
	row--; 
	var myX=(Width - 238 + (column * 32));
	var myY=(Height - 157 + (row * 32));
	skapi.MouseMove(myX,myY);
}
function fPause() 	{skapi.WaitEvent(500,3)}
function fServerPause() {skapi.WaitEvent(1000,3)}


function fHelp()
{
	sSay("Commands are told in fellowship chat: so /f +")
	sSay("xp - Reports XP earned: Total XP + XP by type earned per hour");
	sSay("report - Reports burned items, writes a file with Burned / hr, day, week");
	sSay("prepfile - creates the prepwork files.  Must be run before MakePrep");
	sSay("makeprep - runs the prepwork as shown in ACF-Purchase.txt and ACF-PrepCommands.txt");
	sSay("inventory summary - reports on entire inventory v. Stocking levels.");
	sSay("fillpack - fills the main pack.  Does this by moving 1 item from R1C1 to R1C2... unstable.");
	sSay("adhoc - allows you to tell the bot to create ad-hoc items.  Pls remember, you'll log out after 15 mins w/o moving.");
	sSay("and AC doesnt think you're doing anything while doing adhoc reports... so dont go for more than 100 at any one time.");
	sSay("help - gives this message");
}

function fCheckSpouse()
{
	var ldate = new Date(); 
	// gSay("Spouse Check: "+ldate.getHours()+" >= "+SpouseAbortHour);
	if (ldate.getHours() = SpouseAbortHour)
	{	sSay("True, logging out");
		fLogoutCharacter();
		fSleepSeconds(15);
		skapi.keys("~{ESC}");
		fSleepSeconds(5);
		skapi.keys("y");
		fSleepSeconds(5);
		skapi.keys("~{ESC}");
		fSleepSeconds(5);
		skapi.keys("y");
	}
}


// ----------------------------------------------------------
// Main Function.  Switch to AC, log in char 4, wait for login
// set timers, set spell list, wait around.
// ----------------------------------------------------------
function main()
{
	skapi.AddHandler(evidOnStatSkillExp,hACF);
	skapi.AddHandler(evidOnTellFellowship,hACF);
	skapi.AddHandler(evidOnCommand,hACF);
	var ts = skapi.szArgs.split(", ");
	var Char = parseInt(ts[0]);
	var SpouseAbortHour = parseInt(ts[1]); 
	skapi.OutputLine("skapi.szArgs = "+skapi.szArgs+" or "+Char);
	if (skapi.plig != pligInWorld)
	{	fLoginCharacter(Char);
		while (skapi.plig != pligInWorld) {skapi.WaitEvent(100)}
		fCreateFellowship(ac.MyName + " ");
	}
	StartXP = skapi.expTotal;
	mainpack = skapi.acoChar;
	sSay("Building Inventory");
	fBuildInventory(AlchemySteps);
	fBuildInventory(CookingSteps);
	fBuildInventory(FletchingSteps);
	skapi.WaitEvent(1000);
	fBuildMissingList();
	rSay("Missing Items");
	for (var y=0; y<MissingList.length; y++) {rSay(MissingList[y])}
	sSay("stop, xp, report, earnxp, prepfile, makeprep, adhoc, fillpack");
	while (true) 
	{	skapi.WaitEvent(10000, wemSpecific, evidOnCommand);
		// skapi.WaitEvent(10000,wemSpecific,evidOnTellFellowship);
		if (NewCommand)
		{	sSay("Command Received: "+NewCommand);	
			switch (NewCommand)
			{
			case "earnxp":
				fEarnXP();
				break;
			case "inventory summary":
				fInventorySummary();
				break;
			case "prepfile":
				InventoryList = new Array();
				XPTimer.cmsec = 0;
				ProductionList = new Array();
				PrepCommands = new Array();
				PurchaseList = new Array();
				sSay("Building Inventory");
				fBuildInventory(AlchemySteps);
				fBuildInventory(CookingSteps);
				fBuildInventory(FletchingSteps);
				skapi.WaitEvent(1000);
				fBuildMissingList();
				rSay("Missing Items");
				for (var y=0; y<MissingList.length; y++) {rSay(MissingList[y])}
				sSay("Writing Production File");
				fBuildProductionFile();
				sSay("Writing Purchase File");
				fBuildPurchaseFile();
				sSay("Files Written");
				break;
			case "makeprep":
				fMakePrep(); 
				sSay("Done with Prep");
				break;
			case "fillpack":
				fFillPack(); 
				sSay("Done filling pack");
				break;
			case "adhoc":
				fAdHoc();
				sSay("Ad Hoc Done");
				break;
			case "spouse abort":
				if (SpouseAbort) 
				{	SpouseAbort = false; 
					sSay("Spouse Abort off")
				}
				else 
				{	SpouseAbort = true; 
					sSay("Spouse Abort set for "+SpouseAbortHour+"00 hours.")
				}
				break;
			case "help":
				fHelp()
				break;
			case "just keeping myself logged in.":
				break;
			default:
				sSay("Command unrecognized, '/f help' for help.");
			}
		}
		NewCommand = null;
		skapi.WaitEvent(0);
		fCheckTimers();
		if (SpouseAbort) {fCheckSpouse()}
	}

	
}