
// -------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!!!!!!   R E A D   T H I S   !!!!!!!!!!!!!!!!!!!!!!
// -------------------------------------------------------------------
// !!!  This file is generated automatically by SkapiDefsJs.xsl.   !!!
// !!!    Any edits you make to it by hand WILL be overwritten.    !!!
// !!!         Make your changes to SkapiDefs.xml instead.         !!!
// -------------------------------------------------------------------

// arc: Action result codes
var arcSuccess                  =                           0;	// Your spellcasting attempt (or other action) succeeded.
var arcCombatMode               =                           2;	// One of the parties entered combat mode.
var arcChargedTooFar            =                          28;	// You charged too far!
var arcTooBusy                  =                          29;	// You're too busy!
var arcCantMoveToObject         =                          57;	// Unable to move to object!
var arcCanceled                 =                          81;	// One of the parties canceled or moved out of range.
var arcFatigued                 =                        1015;	// You are too fatigued to attack!
var arcOutOfAmmo                =                        1016;	// You are out of ammunition!
var arcMissleMisfire            =                        1017;	// Your missile attack misfired!
var arcImpossibleSpell          =                        1018;	// You've attempted an impossible spell path!
var arcDontKnowSpell            =                        1022;	// You don't know that spell!
var arcIncorrectTarget          =                        1023;	// Incorrect target type.
var arcOutOfComps               =                        1024;	// You don't have all the components for this spell.
var arcNotEnoughMana            =                        1025;	// You don't have enough Mana to cast this spell.
var arcFizzle                   =                        1026;	// Your spell fizzled.
var arcNoTarget                 =                        1027;	// Your spell's target is missing!
var arcSpellMisfire             =                        1028;	// Your projectile spell mislaunched!

// attr: Attribute IDs
var attrNil                     =                           0;	// No attribute.
var attrStrength                =                           1;
var attrEndurance               =                           2;
var attrQuickness               =                           3;
var attrCoordination            =                           4;
var attrFocus                   =                           5;
var attrSelf                    =                           6;
var attrMax                     =                           7;

// bpart: Body part IDs
var bpartHead                   =                           0;
var bpartChest                  =                           1;
var bpartAbdomen                =                           2;
var bpartUpperArm               =                           3;
var bpartLowerArm               =                           4;
var bpartHand                   =                           5;
var bpartUpperLeg               =                           6;
var bpartLowerLeg               =                           7;
var bpartFoot                   =                           8;

// chop: Character option masks
var chopAutoShortcut            =                  0x00000001;	// Automatically Create Shortcuts
var chopRepeatAttacks           =                  0x00000002;	// Automatically Repeat Attacks
var chopAcceptAllegiance        =                  0x00000004;	// Accept Allegiance Requests (Inverted)
var chopAcceptFellowship        =                  0x00000008;	// Accept Fellowship Requests (Inverted)
var chopInvertMouseLook         =                  0x00000010;	// Invert Mouse Look Up/Down
var chopUnknown                 =                  0x00000020;	// Unknown
var chopAcceptGifts             =                  0x00000040;	// Let Other Players Give You Items
var chopKeepTargetInView        =                  0x00000080;	// Automatically keep combat targets in view
var chopTooltips                =                  0x00000100;	// Display Tooltips
var chopDeceive                 =                  0x00000200;	// Attempt to Deceive Other Players
var chopRunAsDefault            =                  0x00000400;	// Run as Default Movement
var chopStayInChat              =                  0x00000800;	// Stay in Chat Mode after sending a Message
var chopAdvancedCombat          =                  0x00001000;	// Advanced Combet Interface (No Panel)
var chopAutoTarget              =                  0x00002000;	// Auto Target
var chopRClickMouseLook         =                  0x00004000;	// Right-click mouselook
var chopVividTargeting          =                  0x00008000;	// Vivid Targeting Indicator
var chopDisableWeather          =                  0x00010000;	// Disable Most Weather Effects
var chopIgnoreTrade             =                  0x00020000;	// Ignore All Trade Requests
var chopShareXP                 =                  0x00040000;	// Share Fellowship Experience
var chopAcceptCorpsePerm        =                  0x00080000;	// Accept Corpse-Looting Permissions
var chopShareLoot               =                  0x00100000;	// Share Fellowship Loot
var chopStretchUI               =                  0x00200000;	// Stretch UI
var chopShowCoords              =                  0x00400000;	// Show Coordinates Below The Radar
var chopSpellDurations          =                  0x00800000;	// Display Spell Durations
var chopMuteWhenInactive        =                  0x01000000;	// Play Sounds Only When Active Application
var chopDisableHouseFX          =                  0x02000000;	// Disable House Restriction Effects
var chopDragStartsTrade         =                  0x04000000;	// Drag item to player opens Secure Trade

// cmc: Chat message colors
var cmcGreen                    =                           0;
var cmcWhite                    =                           2;	// Local broadcast chat.
var cmcDarkYellow               =                           4;
var cmcRed                      =                           6;
var cmcLightBlue                =                           7;
var cmcDimWhite                 =                          12;
var cmcCyan                     =                          13;
var cmcBlue                     =                          17;	// Spellcasting.

// cmid: Command IDs
// cmid values may be concatenated using the + operator to specify a sequence of commands.
var cmidAllegiancePanel         =         "{AllegiancePanel}";
var cmidAttributesPanel         =         "{AttributesPanel}";
var cmidAutoRun                 =                 "{AutoRun}";
var cmidAutosortSelected        =        "{AutosortSelected}";
var cmidCameraCloser            =            "{CameraCloser}";
var cmidCameraFarther           =           "{CameraFarther}";
var cmidCameraLeftRotate        =        "{CameraLeftRotate}";
var cmidCameraLower             =             "{CameraLower}";
var cmidCameraRaise             =             "{CameraRaise}";
var cmidCameraRightRotate       =       "{CameraRightRotate}";
var cmidCaptureScreenshotToFile = "{CaptureScreenshotToFile}";
var cmidCheer                   =                   "{Cheer}";
var cmidClosestCompassItem      =      "{ClosestCompassItem}";
var cmidClosestItem             =             "{ClosestItem}";
var cmidClosestMonster          =          "{ClosestMonster}";
var cmidClosestPlayer           =           "{ClosestPlayer}";
var cmidCrouch                  =                  "{Crouch}";
var cmidCry                     =                     "{Cry}";
var cmidDecreasePowerSetting    =    "{DecreasePowerSetting}";
var cmidDropSelected            =            "{DropSelected}";
var cmidExamineSelected         =         "{ExamineSelected}";
var cmidFellowshipPanel         =         "{FellowshipPanel}";
var cmidFirstPersonView         =         "{FirstPersonView}";
var cmidFloorView               =               "{FloorView}";
var cmidGiveSelected            =            "{GiveSelected}";
var cmidHighAttack              =              "{HighAttack}";
var cmidHoldRun                 =                 "{HoldRun}";
var cmidHoldSidestep            =            "{HoldSidestep}";
var cmidIncreasePowerSetting    =    "{IncreasePowerSetting}";
var cmidInventoryPanel          =          "{InventoryPanel}";
var cmidJump                    =                    "{Jump}";
var cmidLastAttacker            =            "{LastAttacker}";
var cmidLaugh                   =                   "{Laugh}";
var cmidLowAttack               =               "{LowAttack}";
var cmidMapPanel                =                "{MapPanel}";
var cmidMapView                 =                 "{MapView}";
var cmidMediumAttack            =            "{MediumAttack}";
var cmidNextCompassItem         =         "{NextCompassItem}";
var cmidNextFellow              =              "{NextFellow}";
var cmidNextItem                =                "{NextItem}";
var cmidNextMonster             =             "{NextMonster}";
var cmidNextPlayer              =              "{NextPlayer}";
var cmidOptionsPanel            =            "{OptionsPanel}";
var cmidPointState              =              "{PointState}";
var cmidPreviousCompassItem     =     "{PreviousCompassItem}";
var cmidPreviousFellow          =          "{PreviousFellow}";
var cmidPreviousItem            =            "{PreviousItem}";
var cmidPreviousMonster         =         "{PreviousMonster}";
var cmidPreviousPlayer          =          "{PreviousPlayer}";
var cmidPreviousSelection       =       "{PreviousSelection}";
var cmidReady                   =                   "{Ready}";
var cmidResetView               =               "{ResetView}";
var cmidShiftView               =               "{ShiftView}";
var cmidSideStepLeft            =            "{SideStepLeft}";
var cmidSideStepRight           =           "{SideStepRight}";
var cmidSitting                 =                 "{Sitting}";
var cmidSkillsPanel             =             "{SkillsPanel}";
var cmidSleeping                =                "{Sleeping}";
var cmidSpellbookPanel          =          "{SpellbookPanel}";
var cmidSpellComponentsPanel    =    "{SpellComponentsPanel}";
var cmidSpellResearchPanel      =      "{SpellResearchPanel}";
var cmidSplitSelected           =           "{SplitSelected}";
var cmidToggleCombat            =            "{ToggleCombat}";
var cmidTurnLeft                =                "{TurnLeft}";
var cmidTurnRight               =               "{TurnRight}";
var cmidUseSelected             =             "{UseSelected}";
var cmidWalkBackwards           =           "{WalkBackwards}";
var cmidWalkForward             =             "{WalkForward}";
var cmidWave                    =                    "{Wave}";

// dmty: Damage type masks
// dmty values may be combined using the bitwise OR operator ("|" in JScript, "Or" in VBScript) to indicate more than one type of damage.
var dmtySlashing                =                      0x0001;
var dmtyPiercing                =                      0x0002;
var dmtyBludgeoning             =                      0x0004;
var dmtyCold                    =                      0x0008;
var dmtyFire                    =                      0x0010;
var dmtyAcid                    =                      0x0020;
var dmtyElectrical              =                      0x0040;

// eqm: Equipment type masks
// eqm values may be combined using the bitwise OR operator ("|" in JScript, "Or" in VBScript) to specify multiple equipment slots.
var eqmNil                      =                           0;	// No slot.
var eqmHead                     =                  0x00000001;
var eqmChestUnder               =                  0x00000002;
var eqmAbdomenUnder             =                  0x00000004;
var eqmUpperArmsUnder           =                  0x00000008;
var eqmLowerArmsUnder           =                  0x00000010;
var eqmHands                    =                  0x00000020;
var eqmUpperLegsUnder           =                  0x00000040;
var eqmLowerLegsUnder           =                  0x00000080;
var eqmFeet                     =                  0x00000100;
var eqmChestOuter               =                  0x00000200;
var eqmAbdomenOuter             =                  0x00000400;
var eqmUpperArmsOuter           =                  0x00000800;
var eqmLowerArmsOuter           =                  0x00001000;
var eqmUpperLegsOuter           =                  0x00002000;
var eqmLowerLegsOuter           =                  0x00004000;
var eqmNecklace                 =                  0x00008000;
var eqmRBracelet                =                  0x00010000;
var eqmLBracelet                =                  0x00020000;
var eqmBracelets                =                  0x00030000;	// Both bracelet slots.
var eqmRRing                    =                  0x00040000;
var eqmLRing                    =                  0x00080000;
var eqmRings                    =                  0x000C0000;	// Both ring slots.
var eqmWeapon                   =                  0x00100000;	// Melee weapon slot.
var eqmShield                   =                  0x00200000;
var eqmRangedWeapon             =                  0x00400000;	// Bow or crossbow slot.
var eqmAmmo                     =                  0x00800000;
var eqmFocusWeapon              =                  0x01000000;	// Wand, staff, or orb slot.
var eqmAll                      =                  0x01FFFFFF;	// All equipment slots.

// evid: Event IDs
var evidNil                     =                           0;	// No event was received.
var evidOnVitals                =                           1;
var evidOnLocChangeSelf         =                           2;
var evidOnLocChangeOther        =                           3;
var evidOnStatTotalBurden       =                           4;
var evidOnStatTotalExp          =                           5;
var evidOnStatUnspentExp        =                           6;
var evidOnObjectCreatePlayer    =                           7;
var evidOnStatSkillExp          =                           8;
var evidOnAdjustStack           =                           9;
var evidOnChatLocal             =                          10;
var evidOnChatSpell             =                          11;
var evidOnDeathSelf             =                          12;
var evidOnMyPlayerKill          =                          13;
var evidOnDeathOther            =                          14;
var evidOnEnd3D                 =                          15;
var evidOnStart3D               =                          16;
var evidOnStartPortalSelf       =                          17;
var evidOnEndPortalSelf         =                          18;
var evidOnEndPortalOther        =                          19;
var evidOnCombatMode            =                          20;
var evidOnAnimationSelf         =                          21;
var evidOnTargetHealth          =                          22;
var evidOnAddToInventory        =                          23;
var evidOnRemoveFromInventory   =                          24;
var evidOnAssessCreature        =                          25;
var evidOnAssessItem            =                          26;
var evidOnSpellFailSelf         =                          27;
var evidOnMeleeEvadeSelf        =                          28;
var evidOnMeleeEvadeOther       =                          29;
var evidOnMeleeDamageSelf       =                          30;
var evidOnMeleeDamageOther      =                          31;
var evidOnLogon                 =                          32;
var evidOnTellServer            =                          33;
var evidOnTell                  =                          34;
var evidOnTellMelee             =                          35;
var evidOnTellMisc              =                          36;
var evidOnTellFellowship        =                          37;
var evidOnTellPatron            =                          38;
var evidOnTellVassal            =                          39;
var evidOnTellFollower          =                          40;
var evidOnDeathMessage          =                          41;
var evidOnSpellCastSelf         =                          42;
var evidOnTradeStart            =                          43;
var evidOnTradeEnd              =                          44;
var evidOnTradeAdd              =                          45;
var evidOnTradeReset            =                          46;
var evidOnSetFlagSelf           =                          47;
var evidOnSetFlagOther          =                          48;
var evidOnApproachVendor        =                          49;
var evidOnChatBroadcast         =                          50;
var evidOnTradeAccept           =                          51;
var evidOnObjectCreate          =                          52;
var evidOnChatServer            =                          53;
var evidOnSpellExpire           =                          54;
var evidOnSpellExpireSilent     =                          55;
var evidOnStatTotalPyreals      =                          56;
var evidOnStatLevel             =                          57;
var evidOnChatEmoteStandard     =                          58;
var evidOnChatEmoteCustom       =                          59;
var evidOnOpenContainer         =                          60;
var evidOnPortalStormWarning    =                          61;
var evidOnPortalStormed         =                          62;
var evidOnCommand               =                          63;
var evidOnControlEvent          =                          64;
var evidOnItemManaBar           =                          65;
var evidOnActionComplete        =                          66;
var evidOnObjectDestroy         =                          67;
var evidOnLocChangeCreature     =                          68;
var evidOnMoveItem              =                          69;
var evidOnSpellAdd              =                          70;
var evidOnFellowCreate          =                          71;
var evidOnFellowDisband         =                          72;
var evidOnFellowDismiss         =                          73;
var evidOnFellowQuit            =                          74;
var evidOnFellowRecruit         =                          75;
var evidOnMeleeLastAttacker     =                          76;
var evidMax                     =                          77;

// kmo: Key motions
var kmoDown                     =                        0x01;	// Press the key.
var kmoUp                       =                        0x02;	// Release the key.
var kmoClick                    =                        0x03;	// Press and release.

// material: Material codes
// This list is not exhaustive, but is a sampling of material codes I've seen so far.
var materialLinen               =                  0x00000004;
var materialSatin               =                  0x00000005;
var materialSilk                =                  0x00000006;
var materialVelvet              =                  0x00000007;
var materialAmethyst            =                  0x0000000C;
var materialAquamarine          =                  0x0000000D;
var materialAzurite             =                  0x0000000E;
var materialBloodstone          =                  0x00000011;
var materialCarnelian           =                  0x00000012;
var materialEmerald             =                  0x00000015;
var materialGreenGarnet         =                  0x00000017;
var materialGreenJade           =                  0x00000018;
var materialHematite            =                  0x00000019;
var materialJet                 =                  0x0000001B;
var materialMoonstone           =                  0x0000001F;
var materialOnyx                =                  0x00000020;
var materialRedGarnet           =                  0x00000023;
var materialRedJade             =                  0x00000024;
var materialRoseQuartz          =                  0x00000025;
var materialSmokeyQuartz        =                  0x00000028;
var materialTurquoise           =                  0x0000002C;
var materialWhiteJade           =                  0x0000002D;
var materialYellowTopaz         =                  0x00000031;
var materialIvory               =                  0x00000033;
var materialLeather             =                  0x00000034;
var materialGromnieHide         =                  0x00000036;
var materialBrass               =                  0x00000039;
var materialBronze              =                  0x0000003A;
var materialCopper              =                  0x0000003B;
var materialGold                =                  0x0000003C;
var materialIron                =                  0x0000003D;
var materialPyreal              =                  0x0000003E;
var materialSilver              =                  0x0000003F;
var materialSteel               =                  0x00000040;
var materialEbony               =                  0x00000049;

// mcm: Merchant category masks
var mcmNil                      =                  0x00000000;	// No category; not saleable.
var mcmWeaponsMelee             =                  0x00000001;
var mcmArmor                    =                  0x00000002;
var mcmClothing                 =                  0x00000004;
var mcmJewelry                  =                  0x00000008;
var mcmCreature                 =                  0x00000010;
var mcmFood                     =                  0x00000020;
var mcmPyreal                   =                  0x00000040;
var mcmMisc                     =                  0x00000080;
var mcmWeaponsMissile           =                  0x00000100;
var mcmContainers               =                  0x00000200;
var mcmMiscFletching            =                  0x00000400;
var mcmGems                     =                  0x00000800;
var mcmSpellComponents          =                  0x00001000;
var mcmBooksPaper               =                  0x00002000;
var mcmKeysTools                =                  0x00004000;
var mcmMagicItems               =                  0x00008000;
var mcmPortal                   =                  0x00010000;
var mcmLockable                 =                  0x00020000;
var mcmTradeNotes               =                  0x00040000;
var mcmManaStones               =                  0x00080000;
var mcmServices                 =                  0x00100000;
var mcmPlants                   =                  0x00200000;
var mcmCookingItems1            =                  0x00400000;
var mcmAlchemicalItems1         =                  0x00800000;
var mcmFletchingItems1          =                  0x01000000;
var mcmCookingItems2            =                  0x02000000;
var mcmAlchemicalItems2         =                  0x04000000;
var mcmFletchingItems2          =                  0x08000000;

// Miscellaneous constants
var oidNil                      =                           0;	// Signifies no object.
var ipackMain                   =                           0;	// Index of the main pack.
var iitemNil                    =                          -1;	// Signifies the pack itself.
var clrNil                      =                  0x7FFFFFFF;	// VBScript has a problem with FFFFFFFF (turns it into 0000FFFF).

// ibutton: Mouse button IDs
var ibuttonLeft                 =                           0;	// Left button.
var ibuttonRight                =                           1;	// Right button.
var ibuttonMiddle               =                           2;	// Middle button.

// ocm: Object category masks
// ocm values may be combined using the bitwise OR operator ("|" in JScript, "Or" in VBScript) to specify multiple categories.
var ocmNil                      =                      0x0000;	// Include no objects.
var ocmPlayer                   =                      0x0001;
var ocmMonster                  =                      0x0002;
var ocmPlayerCorpse             =                      0x0004;
var ocmMonsterCorpse            =                      0x0008;
var ocmLifestone                =                      0x0010;
var ocmPortal                   =                      0x0020;
var ocmMerchant                 =                      0x0040;
var ocmEquipment                =                      0x0080;
var ocmPK                       =                      0x0100;
var ocmNonPK                    =                      0x0200;
var ocmNPC                      =                      0x0400;
var ocmAll                      =                          -1;	// Include all nearby objects of any kind.

// olc: Object location categories
// olc values may be combined using the bitwise OR operator ("|" in JScript, "Or" in VBScript) to specify multiple categories.
var olcNil                      =                      0x0000;	// Include no objects.
var olcInventory                =                      0x0001;	// Include objects in your inventory.
var olcContained                =                      0x0002;	// Include objects contained in another object (e.g. a chest or corpse).
var olcEquipped                 =                      0x0004;	// Include objects being worn or wielded (by you or someone else).
var olcOnGround                 =                      0x0008;	// Include objects out on their own in the game world.
var olcAll                      =                          -1;	// Include all object regardless of location.

// oty: Object type masks
var otyContainer                =                  0x00000001;
var otyInscribable              =                  0x00000002;
var otyNoPickup                 =                  0x00000004;
var otyPlayer                   =                  0x00000008;
var otySelectable               =                  0x00000010;
var otyPK                       =                  0x00000020;
var otyReadable                 =                  0x00000100;
var otyMerchant                 =                  0x00000200;
var otyDoor                     =                  0x00001000;
var otyCorpse                   =                  0x00002000;
var otyLifestone                =                  0x00004000;
var otyFood                     =                  0x00008000;
var otyHealingKit               =                  0x00010000;
var otyLockpick                 =                  0x00020000;
var otyPortal                   =                  0x00040000;
var otyFoci                     =                  0x00800000;	// The new magic foci, I think.

// opm: Output modes
// opm values may be combined using the bitwise OR operator ("|" in JScript, "Or" in VBScript) to send output to multiple destinations.
var opmDebugLog                 =                      0x0001;	// Sends the output to the debug terminal (using the Win32 OutputDebugString API).
var opmConsole                  =                      0x0002;	// Sends the output to the SkunkWorks console window.
var opmChatWnd                  =                      0x0010;	// Sends the output to the in-game chat window.

// plig: Player in game codes
var pligNotRunning              =                           0;	// Game is not running.
var pligAtLogin                 =                           1;	// Game is at login screen.
var pligInPortal                =                           2;	// Player is in portal space.
var pligInWorld                 =                           3;	// Player is in the game world.

// psw: Portal storm warning codes
var pswStormEnded               =                           0;	// The portal storm is over.
var pswMildStorm                =                           1;	// Mild portal storm.
var pswHeavyStorm               =                           2;	// Heavy portal storm.

// skid: Skill IDs
var skidNil                     =                           0;	// No skill.
var skidAxe                     =                           1;
var skidBow                     =                           2;
var skidCrossbow                =                           3;
var skidDagger                  =                           4;
var skidMace                    =                           5;
var skidMeleeDefense            =                           6;
var skidMissileDefense          =                           7;
var skidSpear                   =                           9;
var skidStaff                   =                          10;
var skidSword                   =                          11;
var skidThrownWeapons           =                          12;
var skidUnarmedCombat           =                          13;
var skidArcaneLore              =                          14;
var skidMagicDefense            =                          15;
var skidManaConversion          =                          16;
var skidItemTinkering           =                          18;
var skidAssessPerson            =                          19;
var skidDeception               =                          20;
var skidHealing                 =                          21;
var skidJump                    =                          22;
var skidLockpick                =                          23;
var skidRun                     =                          24;
var skidAssessCreature          =                          27;
var skidWeaponTinkering         =                          28;
var skidArmorTinkering          =                          29;
var skidMagicItemTinkering      =                          30;
var skidCreatureEnchantment     =                          31;
var skidItemEnchantment         =                          32;
var skidLifeMagic               =                          33;
var skidWarMagic                =                          34;
var skidLeadership              =                          35;
var skidLoyalty                 =                          36;
var skidFletching               =                          37;
var skidAlchemy                 =                          38;
var skidCooking                 =                          39;
var skidMax                     =                          40;

// skts: Skill training status codes
var sktsUnusable                =                           0;
var sktsUntrained               =                           1;
var sktsTrained                 =                           2;
var sktsSpecialized             =                           3;

// Special key names
// {alt}
// {back}                                                        // Backspace
// {control}
// {del}
// {down}                                                        // Down arrow
// {end}
// {esc}
// {f1}
// {f2}
// {f3}
// {f4}
// {f5}
// {f6}
// {f7}
// {f8}
// {f9}
// {f10}
// {f11}
// {f12}
// {home}
// {ins}
// {keypad 0}
// {keypad 1}
// {keypad 2}
// {keypad 3}
// {keypad 4}
// {keypad 5}
// {keypad 6}
// {keypad 7}
// {keypad 8}
// {keypad 9}
// {keypad *}
// {keypad +}
// {keypad -}
// {keypad /}
// {keypad .}
// {keypad enter}                                                // Keypad Enter
// {left}                                                        // Left arrow
// {numlock}
// {pause}
// {pgdn}
// {pgup}
// {prtsc}                                                       // Print Screen
// {return}                                                      // Enter (the regular one, above RShift)
// {right}                                                       // Right arrow
// {scroll}                                                      // Scroll Lock
// {shift}
// {space}                                                       // Spacebar
// {tab}
// {up}                                                          // Up arrow

// vital: Vital stat codes
var vitalNil                    =                           0;
var vitalHealthMax              =                           1;
var vitalHealthCur              =                           2;
var vitalStaminaMax             =                           3;
var vitalStaminaCur             =                           4;
var vitalManaMax                =                           5;
var vitalManaCur                =                           6;
var vitalMax                    =                           7;

// wem: WaitEvent modes
var wemNormal                   =                           0;	// Returns when timeout elapsed or the queue is empty.
var wemSingle                   =                           1;	// Waits for a single event of any type.
var wemSpecific                 =                           2;	// Waits for a specific event type.
var wemFullTimeout              =                           3;	// Always waits the full timeout interval.


